//
//  NSArray+MBAdditions.h
//  MBMenuExtra
//
//  Created by Michael Bishop on 1/23/10.
//  Copyright 2010 Perforce Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSArray (NGAAdditions)

-(id)arrayByRemovingObjects:(NSArray*)removedObjects;
-(id)arrayByRemovingObject:(id)removedObject;

// Use this when you have an array of dictionaries and you want to create
// a dictionary of dictionaries. You specify which item in each dictionary
// you want to be the key in the resulting dictionary.
// NOTES:
//   * If there are duplicates, the last one wins.
//   * The contents of the dictionaries remain untouched
-(NSDictionary*)NGA_dictionaryByKeyingOnKey:(NSString*)key;

// Use this when you have an array of arrays and you want to create
// a dictionary of arrays. You specify which item in each array
// you want to be the key in the resulting dictionary.
// NOTES:
//   * If there are duplicates, the last one wins.
//   * The contents of the arrays remain untouched
-(NSDictionary*)NGA_dictionaryByKeyingOnIndex:(NSInteger)index;

@end


@interface NSArray (NGAPair)
+(NSArray*) arrayFromFirstObject:(id)firstObject secondObject:(id)secondObject;
-(id) firstObject;
-(id) secondObject;
@end



@interface NSMutableArray (NGAArrayAdditions)

-(void)NGA_setObject:(id)object atIndex:(NSUInteger)index;

@end
