//
//  NSObject+NGAAdditions.h
//  P4Menu
//
//  Created by Michael Bishop on 10/11/11.
//  Copyright 2011 Numerical Garden LLC. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSObject (NGAAdditions)

/// Use this when you have a block of code that will update more than one value in your
/// object and you want to manually notify the system of the changes to those keys.
/// Pass your block in and the keys it modifies and the appropriate KVO notifications will be
/// sent for those keys. Executes immediately on the current thread.
-(void)notifyChangesToKeyValues:(NSSet*)keys occuringInBlock:(void(^)(id unretainedSelf))block;

- (NSArray*)NGA_callStackSymbols;
- (BOOL)NGA_allowsCallStackSymbols;

@end
