//
//  NSString+NGAUTIAdditions.m
//  P4Menu
//
//  Created by Michael Bishop on 1/13/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "NSString+NGAUTIAdditions.h"

@implementation NSString (NGAUTIAdditions)

-(BOOL)conformsToUTI:(NSString*)uti
{
    return UTTypeConformsTo((CFStringRef)self, (CFStringRef)uti);
}

-(NSDictionary*)UTIDeclaration
{
    return [(NSDictionary*)UTTypeCopyDeclaration((CFStringRef)self) autorelease];
}

-(NSURL*)UTIDeclaringBundleURL
{
    return [(NSURL*)UTTypeCopyDeclaringBundleURL((CFStringRef)self) autorelease];
}

-(NSString*)UTIDescription
{
    return [(NSString*)UTTypeCopyDescription((CFStringRef)self) autorelease];
}

-(NSString*)UTIPreferredTagWithClass:(NSString*)classString
{
    return [(NSString*)UTTypeCopyPreferredTagWithClass((CFStringRef)self, (CFStringRef)classString) autorelease];
}

-(NSArray*)UTIAllIdentifiersForTag:(NSString*)tag conformingToUTI:(NSString*)uti
{
    return [(NSArray*)UTTypeCreateAllIdentifiersForTag((CFStringRef)self, (CFStringRef)tag, (CFStringRef)uti ) autorelease];
}

-(NSString*)UTIPreferredIdentifiersForTag:(NSString*)tag conformingToUTI:(NSString*)uti;
{
    return [(NSString*)UTTypeCreatePreferredIdentifierForTag((CFStringRef)self, (CFStringRef)tag, (CFStringRef)uti ) autorelease];
}

-(OSType)OSType
{
    return UTGetOSTypeFromString((CFStringRef)self);
}

+(NSString*)UTIForOSType:(OSType)osType;
{
    return [(NSString*)UTCreateStringForOSType(osType) autorelease];
}

@end
